/*
 *   MIRACL calculate pi - by Gauss-Legendre method
 *   bnpi.c
 */
  
#include "miracl.h"

/* Access global variables */

extern  int depth;     /* error tracing .. */
extern  int trace[];   /* ... mechanism    */
extern  int nib;       /* length of bigs   */
extern  int lg2b;      /* bits in base     */

extern big  w11,w12,w13,w15; /* workspace variables */

void fpi(pi)
flash pi;
{ /* Calculate pi using Guass-Legendre method */
    int x,nits;
    if (ERNUM) return;
    depth++;
    trace[depth]=53;
    if (TRACER) track();
    if (size(w15)!=0)
    {
        copy(w15,pi);
        EXACT=FALSE;
        depth--;
        return;
    }
    fconv(1,2,pi);
    froot(pi,2,pi);
    fconv(1,1,w11);
    fconv(1,4,w12);
    x=1;
    nits=lg2b*nib/4;
    while (x<nits)
    {
        copy(w11,w13);
        fadd(w11,pi,w11);
        fpmul(w11,1,2,w11);
        fmul(pi,w13,pi);
        froot(pi,2,pi);
        fsub(w11,w13,w13);
        fmul(w13,w13,w13);
        fpmul(w13,x,1,w13);
        fsub(w12,w13,w12);
        x*=2;
    }
    fadd(w11,pi,pi);
    fmul(pi,pi,pi);
    fpmul(w12,4,1,w12);
    fdiv(pi,w12,pi);
    copy(pi,w15);
    depth--;
}
