/*
 *   Program to factor big numbers using Brent-Pollard method.
 *   See "An Improved Monte Carlo Factorization Algorithm"
 *   by Richard Brent in BIT Vol. 20 1980 pp 176-184
 */

#include <stdio.h>
#include "miracl.h"

#define min(a,b) ((a) < (b)? (a) : (b))

main()
{  /*  factoring program using Brents method */
    long k,r,i,m;
    big x,y,z,n,q,ys,c3;
    mirsys(50,MAXBASE);
    x=mirvar(0);
    y=mirvar(0);
    ys=mirvar(0);
    z=mirvar(0);
    n=mirvar(0);
    q=mirvar(0);
    c3=mirvar(3);
    printf("input number to be factored\n");
    cinnum(n,stdin);
    m=10;
    r=1;
    printf("factors are \n1\n");
    while (!prime(n))
    {
        convert(1,q);
        do
        {
            copy(y,x);
            for (i=1;i<=r;i++)
                mad(y,y,c3,n,n,y);
            k=0;
            do
            {
                copy(y,ys);
                for (i=1;i<=min(m,r-k);i++)
                {
                    mad(y,y,c3,n,n,y);
                    subtract(y,x,z);
                    mad(z,q,q,n,n,q);
                }
                gcd(q,n,z);
                k+=m;
            } while (k<r && size(z)==1);
            r*=2;
        } while (size(z)==1);
        if (compare(z,n)==0) do 
        { /* back-track */
            mad(ys,ys,c3,n,n,ys);
            subtract(ys,x,z);
            gcd(z,n,z);
        } while (size(z)==1);
        if (!prime(z))
            printf("failed to factor further\n");
        if (compare(z,n)==0) break;
        cotnum(z,stdout);
        divide(n,z,n);
        divide(y,n,n);
    }       
    cotnum(n,stdout);
}
