/* cvtfns.c - Conversion functions from ints to strings

	0.01 - Initial version.					18/01/90

    Copyright 1990 By Nildram Software                */

/* uctostring = unsigned char to string */

unsigned char *uctostring(unsigned char ch, unsigned char *string)
	{
	*string = ch;
	*(string + 1) = 0;
	return string;
	}

/* ctostring = char to string */

unsigned char *ctostring(char ch, unsigned char *string)
	{
	*string = ch + 128;
	*(string + 1) = 0;
	return string;
	}

unsigned char stringtouc(unsigned char *string)
	{
	return *string;
	}

char stringtoc(unsigned char *string)
	{
	return *string - 128;
	}

/* uitostring = unsigned int to string */

unsigned char *uitostring(unsigned int i, unsigned char *string)
	{
	*string = (i >= (unsigned)65025) ? 2 : 1;
	*(string + 1) = ((i / 255) % 255) + 1;
	*(string + 2) = (i % 255) + 1;
	*(string + 3) = 0;
	return string;
	}

/* itostring = unsigned int to string */

unsigned char *itostring(int si, unsigned char *string)
	{
	register unsigned int i = si + (unsigned)32768;
	*string = (i >= (unsigned)65025) ? 2 : 1;
	*(string + 1) = ((i / 255) % 255) + 1;
	*(string + 2) = (i % 255) + 1;
	*(string + 3) = 0;
	return string;
	}

unsigned int stringtoui(unsigned char *string)
	{
	return (*string - 1) * 65025 + (*(string + 1) - 1) * 255 +
		*(string + 2) - 1;
	}

int stringtoi(unsigned char *string)
	{
	register unsigned int retval;
	retval = (*string - 1) * 65025 + (*(string + 1) - 1) * 255 +
		*(string + 2) - 1 - 32768;
	return retval;
	}

/* ultostring = unsigned long to string */

unsigned char *ultostring(unsigned long i, unsigned char *string)
	{
	uitostring(i / 65536, string);
	uitostring(i % 65536, string + 3);
	return string;
	}

unsigned char *ltostring(long si, unsigned char *string)
	{
	return ultostring((unsigned long)si, string);
	}

unsigned long stringtoul(unsigned char *string)
	{
	return ((unsigned long)stringtoui(string) * 65536) + 
		stringtoui(string + 3);
	}

long stringtol(unsigned char *string)
	{
	return (long)(stringtoul(string));
	}

