/* dds.h Header file.

	0.01 - Started history.					11/01/90
	0.02 - Structure alignment problem fixed by altering
	       special.						12/09/90

        Copyright 1990 By Nildram Software                               */

#ifndef DDS_H
#define DDS_H

#include <stdlib.h>
#include <fscreen.h>
#include <string.h>

#if __cplusplus
extern "C" {
#endif

#ifndef NULL
#if LPTR
#define NULL 0L
#else
#define NULL 0
#endif
#endif

char *cvt_btos(void *, int, char *);
void *cvt_stob(char *, void *);
int DDdelete(int);
int DDfind(int);
int DDnext(int);
int DDprev(int);
void DDuseidx(int,char *);
void DDinsert(int);
void DDexit(int);
void _DDdisplay(void *, int);
void _DDdisplayall(int);
int _DDinput(void *, int);
void _DDpntscr(int, int);
void DDinit(void);
void DDopen(int);
int DDfnlist(int, ...);
int DDamend(int);
void DDclearfbuf(int);
int DDrewind(int);
int DDffwd(int);
int DDretrieve(int);
void DDmark(int);
int DDgotomark(int);
void DDclose(int);
void DDcloseall(void);
void DDopenall(void);
void DDflush(void);
void cvt_from_array(int, char **);
char **cvt_to_array(int);
char **cvt_to_array_idx(int);
unsigned char *uctostring(unsigned char ch, unsigned char *string);
unsigned char *ctostring(char ch, unsigned char *string);
unsigned char stringtouc(unsigned char *string);
char stringtoc(unsigned char *string);
unsigned char *uitostring(unsigned int i, unsigned char *string);
unsigned char *itostring(int si, unsigned char *string);
unsigned int stringtoui(unsigned char *string);
int stringtoi(unsigned char *string);
unsigned char *ultostring(unsigned long i, unsigned char *string);
unsigned char *ltostring(long si, unsigned char *string);
unsigned long stringtoul(unsigned char *string);
long stringtol(unsigned char *string);

char *ltoa(long, char *, int);
char *ltod(long, char *);
long dtol(char *);
long parsedate(int, int, int);
long today(void);

struct DDfile_struct
	{
	int fileno;					     /* File number */
	char *path;				      /* File path and name */
	char *mainidx;				      /* Primary index name */
	};

struct DDdisp_struct
	{
	int startx;					/* Start row of box */
	int starty;				     /* Start column of box */
	int length;					   /* Length of box */
	int type;					/* type of variable */
	void *varptr;				     /* Pointer to variable */
	char *allowed;			    /* String of allowed characters */
	char *title;					    /* Title of box */
	int special;					   /* Special Field */
	int scroll;				    /* Length of scroll box */
	char *boxdef;				/* Box character definition */
	};

extern int DDerr;
extern int DDnelems[16];
extern struct DDdisp_struct *DDscreen[16];
extern int DDcurrscr;
extern char DDcurridx[32][32];
extern int DDscroll;
extern struct DDfile_struct DDfile[32];

#define safstrcpy(a, b) strncpy(a, b, sizeof(a) - 1); a[sizeof(a) - 1] = 0;

#define DD_NSR		1				  /* No Such Record */
#define DD_BS		2				       /* Backspace */
#define DD_CUP		4				       /* Cursor Up */
#define DD_CDN		8				     /* Cursor Down */
#define DD_ENTER	16				       /* Enter Key */
#define DD_PGUP		32					 /* Page Up */
#define DD_PGDN		64				       /* Page Down */
#define DD_ESC		512				      /* Escape Key */
#define DD_NRS		1024			      /* No record Selected */
#define DD_BACK		(DD_BS | DD_CUP | DD_PGUP)	       /* Backwards */
#define DD_FWD		(DD_CDN | DD_ENTER | DD_PGDN)		/* Forwards */

#define DD_CHAR 0
#define DD_INT 1
#define DD_LONG 2
#define DD_DATE 3
#define DD_STRING 5
#define DD_UCHAR 6
#define DD_UINT 7
#define DD_ULONG 8

#define DDdelete(a) DDdelete(a.fileno)
#define DDfind(a) DDfind(a.fileno)
#define DDnext(a) DDnext(a.fileno)
#define DDprev(a) DDprev(a.fileno)
#define DDuseidx(a, b) DDuseidx(a.fileno, b)
#define DDinsert(a) DDinsert(a.fileno)
#define DDopen(a) DDopen(a.fileno)
#define DDamend(a) DDamend(a.fileno)
#define DDclearfbuf(a) DDclearfbuf(a.fileno)
#define DDrewind(a) DDrewind(a.fileno)
#define DDffwd(a) DDffwd(a.fileno)
#define DDretrieve(a) DDretrieve(a.fileno)
#define DDmark(a) DDmark(a.fileno)
#define DDgotomark(a) DDgotomark(a.fileno)
#define DDclose(a) DDclose(a.fileno)

#define exit(a) DDexit(a)

#define DDINCOL  LIGHTGREY
#define DDLEGCOL WHITE
#define DDBOXCOL YELLOW
#define DDBMNORM (BLUE << 4) | YELLOW
#define DDBMHIGH (CYAN << 4) | BLUE
#define DDBMHOTK (BLUE << 4) | WHITE
#define DDMNORM  (BLUE << 4) | LIGHTGREY
#define DDMHIGH  YELLOW
#define DDTITCOL (RED << 4) | WHITE
#define DDPRCOL  LIGHTGREY

#define DDinput(a) _DDinput(a, DDINCOL)
#define DDdisplay(a) _DDdisplay(a, DDINCOL)
#define DDdisplayall() _DDdisplayall(DDINCOL)
#define DDpntscr() _DDpntscr(DDLEGCOL, DDBOXCOL)
#define DDbarmenu(a, b, c, d) \
			FSbarmenu(a, b, c, d, DDBMNORM, DDBMHIGH, DDBMHOTK)
#define DDmenu(a, b, c, d) FSmenu(a, b, c, d, DDMNORM, DDMHIGH)
#define DDtitle(a, b) FStitle(a, DDTITCOL, b)
#define DDprompt(a, b) FSprompt(a, DDPRCOL, b)
#endif

#define NEWIDX "n$q!%&^|--{}"
#define RBIDX  "r$q!%&^|--{}"
#define CHKIDX "c$q!%&^|--{}"

#if __cplusplus
	}
#endif
