/*
 *   Program to encipher text using OKAMOTO public key.
 */

#include <stdio.h>
#include "miracl.h"

void strip(name)
char name[];
{ /* strip off filename extension */
    int i;
    for (i=0;name[i]!='\0';i++)
    {
        if (name[i]!='.') continue;
        name[i]='\0';
        break;
    }
}

main()
{  /*  encipher using public key  */
    big e,m,n,u,mx;
    FILE *ifile;
    FILE *ofile;
    static char line[500];
    char ifname[13],ofname[13];
    bool fli,last;
    int i,ipt,klen;
    mirsys(100,MAXBASE);
    e=mirvar(0);
    m=mirvar(0);
    n=mirvar(0);
    u=mirvar(0);
    mx=mirvar(0);
    IOBASE=60;
    ifile=fopen("public.key","r");
    cinnum(n,ifile);
    cinnum(u,ifile);
    fclose(ifile);
    root(n,3,mx);
    subdiv(mx,2,mx);
    klen=0;
    while (size(mx)>0)
    { /* find max message length in characters */
        klen++;
        subdiv(mx,128,mx);
    }
    klen--;
    printf("file to be enciphered = ");
    gets(ifname);
    fli=FALSE;
    if (strlen(ifname)>0) fli=TRUE;
    if (fli)
    { /* set up input file */
        strcpy(ofname,ifname);
        strip(ofname);
        strcat(ofname,".oka");
        ifile=fopen(ifname,"r");
        printf("enciphering message\n");
    }
    else
    { /* accept input from keyboard */
        ifile=stdin;
        do
        {
            printf("output filename = ");
            gets(ofname); 
        } while (strlen(ofname)==0);
        strip(ofname);    
        strcat(ofname,".oka");
        printf("input message - finish with cntrl z\n");
    }
    ofile=fopen(ofname,"w");
    WRAP=OFF;
    ipt=0;
    last=FALSE;
    while (!last)
    { /* encipher line by line */
        if (fgets(&line[ipt],132,ifile)==NULL) last=TRUE;
        if (line[ipt]==EOF) last=TRUE;
        ipt=strlen(line);
        if (ipt<klen && !last) continue;
        while (ipt>=klen)
        { /* chop up into klen-sized chunks and encipher */
            for (i=0;i<klen;i++)
                IBUFF[i]=line[i];
            IBUFF[klen]='\0';
            for (i=klen;i<=ipt;i++)
                line[i-klen]=line[i];
            ipt-=klen;
            IOBASE=128;
            cinnum(m,ifile);
            add(m,u,m);
            mad(m,m,m,n,n,e);
            IOBASE=60;
            cotnum(e,ofile);
        }
        if (last && ipt>0)
        { /* now deal with left overs */
            strcpy(IBUFF,line);
            IOBASE=128;
            cinnum(m,ifile);
            add(m,u,m);
            mad(m,m,m,n,n,e);
            IOBASE=60;
            cotnum(e,ofile);
        }
    }
    fclose(ofile);
    if (fli) fclose(ifile);
}   
