#ifndef FSCREEN_H
#define FSCREEN_H

#if __cplusplus
extern "C" {
#endif

void FSputa(char, int, int, int);
void FSputs(const char *, char, int, int);
unsigned FSgetxy(int, int);
void FSinit(void);
void FSbox(int, int, int, int, int, int);
void FSgotopos(int, int);
void FSgetpos(int *, int *);
void FSsetstyle(int, int);
void FSgetstyle(int *, int *);
int  FSreadscr(int, int, int, int);
int  FSwritescr(int, int, int, int);
int  FSopwin(int, int, int, int, int, int);
int  FSclwin(void);
void FSscroll(int, int, int, int, int);
int  FSmenu(int, int, int, const char **, int, int);
int  FSinput(int, int, int, int, int, const char *, char *);
int  FSbarmenu(int, int, int, char **, int, int, int);
int  FSyesno(int, int, int);
int  FSgetch(void);
int FSprompt(char *, int, int);

#if __cplusplus
	}
#endif

#define FStitle(a, b, c) FSputs(a, b, c, 39 - strlen(a) / 2)
#define FSclrbox(topx, topy, botx, boty) FSscroll(topx, topy, botx, boty, 0)
#define FSclrline(line) FSscroll(line, 0, line, 79, 0)
#define FSclrscr() FSscroll(0, 0, 24, 79, 0)

#ifndef BLACK
#define BLACK 0
#endif

#ifndef BLUE
#define BLUE 1
#endif

#ifndef GREEN
#define GREEN 2
#endif

#ifndef CYAN
#define CYAN 3
#endif

#ifndef RED
#define RED 4
#endif

#ifndef MAGENTA
#define MAGENTA 5
#endif

#ifndef BROWN
#define BROWN 6
#endif

#ifndef LIGHTGREY
#define LIGHTGREY 7
#endif

#ifndef DARKGREY
#define DARKGREY 8
#endif

#ifndef LIGHTBLUE
#define LIGHTBLUE 9
#endif

#ifndef LIGHTGREEN
#define LIGHTGREEN 10
#endif

#ifndef LIGHTCYAN
#define LIGHTCYAN 11
#endif

#ifndef LIGHTRED
#define LIGHTRED 12
#endif

#ifndef LIGHTMAGENTA
#define LIGHTMAGENTA 13
#endif

#ifndef YELLOW
#define YELLOW 14
#endif

#ifndef WHITE
#define WHITE 15
#endif

#ifndef BLINK
#define BLINK 0x80
#endif

#define FS_CURSORUP 1
#define FS_CURSORDOWN 2
#define FS_BACKSPACE 3
#define FS_ENTER 4
#define FS_ESCAPE 5
#define FS_PGUP 6
#define FS_PGDN 7

#define TOUPPER 1
#define TOLOWER 2

#define ALNUM "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm1234567890_"
#define NUM "1234567890 "
#define ALL "^"

/* The following are for FSbox styles */

#define HSVS 0
#define HDVD 1
#define HDVS 2
#define HSVD 3

/* For FSbarmenu */

#define FS_CENTRE (-1)
#endif
