/*
 *   Program to generate OKAMOTO keys.
 */

#include <stdio.h>
#include "miracl.h"

main()
{  /*  calculate public and private keys  *
    *  for oka encryption                 */
    int n1,n2,k;
    long seed;
    big p,q,pq,u,a,n;
    FILE *outfile;
    mirsys(100,MAXBASE);
    printf("random number seed = ");
    scanf("%ld",&seed);
    getchar();
    irand(seed);
    p=mirvar(0);
    q=mirvar(0);
    pq=mirvar(0);
    u=mirvar(0);
    a=mirvar(0);
    n=mirvar(0);
    k=0;
    do
    {
        printf("minimum size of keys in decimal digits= ");
        scanf("%d",&k);
        getchar();
    } while (k<30);
    printf("generating keys - please wait\n");
    n1=k/3+4;
    n2=k/3-2;
    do
    { /* ensure p>>q */
        strongp(p,n1);
        strongp(q,n2);
        premult(q,1000,pq);
    } while (compare(p,pq)<=0);
    multiply(p,q,pq);
    root(pq,2,u);
    subdiv(u,2,u);
    do
    {
        bigrand(u,a);
        gcd(a,pq,n);
    } while (size(n)!=1);
    bigrand(q,u);
    multiply(pq,q,n);
    multiply(pq,u,u);
    add(u,a,u);
    printf("public encryption key\n");
    cotnum(n,stdout);
    cotnum(u,stdout);
    printf("private decryption key\n");
    cotnum(p,stdout);
    cotnum(q,stdout);
    cotnum(a,stdout);
    WRAP=OFF;
    IOBASE=60;
    outfile=fopen("public.key","w");
    cotnum(n,outfile);
    cotnum(u,outfile);
    fclose(outfile);
    outfile=fopen("private.key","w");
    cotnum(p,outfile);
    cotnum(q,outfile);
    cotnum(a,outfile);
    fclose(outfile);
}
